# -------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
# -------------------------------------------------------------

# Autogenerated By   : src/main/python/generator/generator.py
# Autogenerated From : scripts/builtin/f1Score.dml

from typing import Dict, Iterable

from systemds.operator import OperationNode, Matrix, Frame, List, MultiReturn, Scalar
from systemds.utils.consts import VALID_INPUT_TYPES


def f1Score(P: Matrix,
            Y: Matrix):
    """
     Computes the F1 score as the harmonic mean of precision and recall.
     F1 = 2TP / (2TP + FP + FN)
    
    
    
    :param P: vector of predictions (1-based, recoded)
    :param Y: vector of actual labels (1-based, recoded)
    :return: the F1 score
    """

    params_dict = {'P': P, 'Y': Y}
    return Matrix(P.sds_context,
        'f1Score',
        named_input_nodes=params_dict)
