# -------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
# -------------------------------------------------------------

# Autogenerated By   : src/main/python/generator/generator.py
# Autogenerated From : scripts/builtin/flattenQuantile.dml

from typing import Dict, Iterable

from systemds.operator import OperationNode, Matrix, Frame, List, MultiReturn, Scalar
from systemds.utils.consts import VALID_INPUT_TYPES


def flattenQuantile(X: Matrix,
                    P: Matrix):
    """
     Returns the quantiles requested, but treating the input matrix X as a flattened matrix
     to return quantiles of all cells as if it was a continuous allocation.
    
    
    
    :param X: Matrix with values to extract quantiles from.
    :param P: Quantiles to extract as well if empty matrix not calculated
    :return: Quantiles calculated
    """

    params_dict = {'X': X, 'P': P}
    return Matrix(X.sds_context,
        'flattenQuantile',
        named_input_nodes=params_dict)
