# -------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
# -------------------------------------------------------------

# Autogenerated By   : src/main/python/generator/generator.py
# Autogenerated From : scripts/builtin/lmPredictStats.dml

from typing import Dict, Iterable

from systemds.operator import OperationNode, Matrix, Frame, List, MultiReturn, Scalar
from systemds.utils.consts import VALID_INPUT_TYPES


def lmPredictStats(yhat: Matrix,
                   ytest: Matrix,
                   lm: bool):
    """
     This builtin function computes and prints a summary of accuracy
     measures for regression problems.
    
    
    
    :param yhat: A column vector of predicted response values y
    :param ytest: A column vector of actual response values y
    :param lm: An indicator if used for linear regression model
    :return: A column vector holding avg_res, ss_avg_res, and R2
    """

    params_dict = {'yhat': yhat, 'ytest': ytest, 'lm': lm}
    return Matrix(yhat.sds_context,
        'lmPredictStats',
        named_input_nodes=params_dict)
