# -------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
# -------------------------------------------------------------

# Autogenerated By   : src/main/python/generator/generator.py
# Autogenerated From : scripts/builtin/raSelection.dml

from typing import Dict, Iterable

from systemds.operator import OperationNode, Matrix, Frame, List, MultiReturn, Scalar
from systemds.utils.consts import VALID_INPUT_TYPES


def raSelection(X: Matrix,
                col: int,
                op: str,
                val: float):
    """
     This raSelection-function takes a matrix data set as input from where it performs
     relational operations : selection
    
    
    
    :param X: Matrix of input data [shape: N x M]
    :param col: Integer indicating the column index to execute selection command
    :param op: String specifying the comparison operator (e.g., ">", "<", "==").
    :param val: Constant value to compare the column values "with col op val"
    :return: Matrix of selected data [shape N' x M] with N' <= N
    """

    params_dict = {'X': X, 'col': col, 'op': op, 'val': val}
    return Matrix(X.sds_context,
        'raSelection',
        named_input_nodes=params_dict)
