# -------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
# -------------------------------------------------------------

# Autogenerated By   : src/main/python/generator/generator.py
# Autogenerated From : scripts/builtin/sliceLineDebug.dml

from typing import Dict, Iterable

from systemds.operator import OperationNode, Matrix, Frame, List, MultiReturn, Scalar
from systemds.utils.consts import VALID_INPUT_TYPES


def sliceLineDebug(TK: Matrix,
                   TKC: Matrix,
                   tfmeta: Frame,
                   tfspec: str):
    """
     This builtin function takes the outputs of SliceLine and the
     original transformencode meta data in order to print a human-
     readable debug output of the resulting top-k slices.
    
    
    
    :param TK: top-k slices (k x ncol(X) if successful)
    :param TKC: score, total/max error, size of slices (k x 4)
    :param tfmeta: transformencode meta data
    :param tfspec: transform specification
    :return: debug output collected as a string
    """

    params_dict = {'TK': TK, 'TKC': TKC, 'tfmeta': tfmeta, 'tfspec': tfspec}
    return Matrix(TK.sds_context,
        'sliceLineDebug',
        named_input_nodes=params_dict)
