# -------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
# -------------------------------------------------------------

# Autogenerated By   : src/main/python/generator/generator.py
# Autogenerated From : scripts/builtin/sliceLineExtract.dml

from typing import Dict, Iterable

from systemds.operator import OperationNode, Matrix, Frame, List, MultiReturn, Scalar
from systemds.utils.consts import VALID_INPUT_TYPES


def sliceLineExtract(X: Matrix,
                     e: Matrix,
                     TK: Matrix,
                     TKC: Matrix,
                     **kwargs: Dict[str, VALID_INPUT_TYPES]):
    """
     This builtin function takes the outputs of SliceLine and allows
    
    
    
    
    :param X: Feature matrix in recoded/binned representation
    :param e: Error vector of trained model
    :param TK: top-k slices (k x ncol(X) if successful)
    :param TKC: score, total/max error, size of slices (k x 4)
    :param k2: fist k2 slices to extract with k2 <= k
    :return: Selected rows from X which belong to k2 top slices
    :return: Selected rows from e which belong to k2 top slices
    """

    params_dict = {'X': X, 'e': e, 'TK': TK, 'TKC': TKC}
    params_dict.update(kwargs)
    
    vX_0 = Matrix(X.sds_context, '')
    vX_1 = Matrix(X.sds_context, '')
    vX_2 = Matrix(X.sds_context, '')
    output_nodes = [vX_0, vX_1, vX_2, ]

    op = MultiReturn(X.sds_context, 'sliceLineExtract', output_nodes, named_input_nodes=params_dict)

    vX_0._unnamed_input_nodes = [op]
    vX_1._unnamed_input_nodes = [op]
    vX_2._unnamed_input_nodes = [op]

    return op
